// CDUCCSVG.h :  Microsoft Visual C++  ActiveX ؼװ

#pragma once

/////////////////////////////////////////////////////////////////////////////
// CDUCCSVG

// Dispatch interfaces referenced by this interface
#include "xdpage.h"
#include "xdwindow.h"
#include "xdshape.h"
#include "xdgroupshape.h"
#include "xdlinkshape.h"
#include "xdportsshape.h"
#include "xdportshape.h"
#include "xdeformshape.h"

class CDUCCSVG : public CWnd
{
protected:
	DECLARE_DYNCREATE(CDUCCSVG)
public:
	CLSID const& GetClsid()
	{
		static CLSID const clsid
			= { 0xBCAAF5C7, 0xB58, 0x4D15, { 0xA5, 0x3A, 0x2C, 0x82, 0xDB, 0x8, 0x93, 0x35 } };
		return clsid;
	}
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle,
						const RECT& rect, CWnd* pParentWnd, UINT nID, 
						CCreateContext* pContext = NULL)
	{ 
		return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID); 
	}

    BOOL Create(LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, 
				UINT nID, CFile* pPersist = NULL, BOOL bStorage = FALSE,
				BSTR bstrLicKey = NULL)
	{ 
		return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID,
		pPersist, bStorage, bstrLicKey); 
	}

// 
public:

public:
	long AddRectShape(long xLeft, long xTop, long xRight, long xBottom, LPCTSTR lpszCaption)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR;
		InvokeHelper(0x3, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xLeft, xTop, xRight, xBottom, lpszCaption);
		return result;
	}
	long AddTextShape(long xLeft, long xTop, long xRight, long xBottom, LPCTSTR lpszText)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR;
		InvokeHelper(0x4, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xLeft, xTop, xRight, xBottom, lpszText);
		return result;
	}
	long AddEllipseShape(long xLeft, long xTop, long xRight, long xBottom, LPCTSTR lpszCaption)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR;
		InvokeHelper(0x5, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xLeft, xTop, xRight, xBottom, lpszCaption);
		return result;
	}
	long AddRoundRectShape(long xLeft, long xTop, long xRight, long xBottom)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x6, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xLeft, xTop, xRight, xBottom);
		return result;
	}
	long AddHyLinkShape(long xLeft, long yTop, long xRight, long yBottom, LPCTSTR lpszCaption)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR;
		InvokeHelper(0x7, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xLeft, yTop, xRight, yBottom, lpszCaption);
		return result;
	}
	long AddBmpFileShape(long xLeft, long yTop, long xRight, long yBottom, LPCTSTR lpszFileName, LPCTSTR lpszCaption)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR;
		InvokeHelper(0x8, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xLeft, yTop, xRight, yBottom, lpszFileName, lpszCaption);
		return result;
	}
	long AddEmfFileShape(long xLeft, long yTop, long xRight, long yBottom, LPCTSTR lpszFileName, LPCTSTR lpszCaption)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR;
		InvokeHelper(0x9, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xLeft, yTop, xRight, yBottom, lpszFileName, lpszCaption);
		return result;
	}
	long AddWmfFileShape(long xLeft, long yTop, long xRight, long yBottom, LPCTSTR lpszFileName, LPCTSTR lpszCaption)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR;
		InvokeHelper(0xa, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xLeft, yTop, xRight, yBottom, lpszFileName, lpszCaption);
		return result;
	}
	long AddShapeByType(long nType, long xLeft, long yTop, long xRight, long yBottom, LPCTSTR lpszFileName)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR;
		InvokeHelper(0xb, DISPATCH_METHOD, VT_I4, (void*)&result, parms, nType, xLeft, yTop, xRight, yBottom, lpszFileName);
		return result;
	}
	long AddCompositeShapeByFile(long xLeft, long xTop, long xRight, long xBottom, LPCTSTR lpszFileName, LPCTSTR lpszCaption)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR;
		InvokeHelper(0xc, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xLeft, xTop, xRight, xBottom, lpszFileName, lpszCaption);
		return result;
	}
	long AddCompositeShapeByID(long xLeft, long yTop, long xRight, long yBottom, long nResId, LPCTSTR lpszCaption)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR;
		InvokeHelper(0xd, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xLeft, yTop, xRight, yBottom, nResId, lpszCaption);
		return result;
	}
	long AddLineShape(long xStart, long yStart, long xEnd, long yEnd, BOOL bArrow)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
		InvokeHelper(0xe, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xStart, yStart, xEnd, yEnd, bArrow);
		return result;
	}
	long AddDimLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
		InvokeHelper(0xf, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xStart, yStart, xEnd, yEnd, nWidth, bArrow);
		return result;
	}
	BOOL Read(LPCTSTR lpszFileName)
	{
		BOOL result;
		static BYTE parms[] = VTS_BSTR;
		InvokeHelper(0x10, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, lpszFileName);
		return result;
	}
	BOOL Write(LPCTSTR lpszFileName)
	{
		BOOL result;
		static BYTE parms[] = VTS_BSTR;
		InvokeHelper(0x11, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, lpszFileName);
		return result;
	}
	void Export()
	{
		InvokeHelper(0x12, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void Undo()
	{
		InvokeHelper(0x13, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void Redo()
	{
		InvokeHelper(0x14, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void Cut()
	{
		InvokeHelper(0x15, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void Copy()
	{
		InvokeHelper(0x16, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void Paste()
	{
		InvokeHelper(0x17, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void Clear()
	{
		InvokeHelper(0x18, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void ClearAll()
	{
		InvokeHelper(0x19, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void SelectAll()
	{
		InvokeHelper(0x1a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL GetShowGrid()
	{
		BOOL result;
		InvokeHelper(0x1b, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void SetShowGrid(BOOL bGrid)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x1c, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bGrid);
	}
	void OnGridProp()
	{
		InvokeHelper(0x1d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL GetDesignMode()
	{
		BOOL result;
		InvokeHelper(0x1e, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void SetDesignMode(BOOL bMode)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x1f, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bMode);
	}
	BOOL GetSnapToGrid()
	{
		BOOL result;
		InvokeHelper(0x20, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void SetSnapToGrid(BOOL bSnap)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x21, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bSnap);
	}
	BOOL GetGlueToHandle()
	{
		BOOL result;
		InvokeHelper(0x22, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void SetGlueToHandle(BOOL bGlue)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x23, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bGlue);
	}
	BOOL GetShowPageBreakLine()
	{
		BOOL result;
		InvokeHelper(0x24, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void SetShowPageBreakLine(BOOL bShow)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x25, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bShow);
	}
	BOOL GetShowPort()
	{
		BOOL result;
		InvokeHelper(0x26, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void SetShowPort(BOOL bShow)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x27, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bShow);
	}
	long GetZoomPercent()
	{
		long result;
		InvokeHelper(0x28, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	void SetZoomPercent(long nZoom)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x29, DISPATCH_METHOD, VT_EMPTY, NULL, parms, nZoom);
	}
	void ZoomIn()
	{
		InvokeHelper(0x2a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void ZoomOut()
	{
		InvokeHelper(0x2b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void ZoomToFitPage()
	{
		InvokeHelper(0x2c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void ZoomToFitPageHeight()
	{
		InvokeHelper(0x2d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void ZoomToFitPageWidth()
	{
		InvokeHelper(0x2e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void ZoomToFitSelect()
	{
		InvokeHelper(0x2f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void ZoomToRect(long xLeft, long yTop, long xRight, long yBottom)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x30, DISPATCH_METHOD, VT_EMPTY, NULL, parms, xLeft, yTop, xRight, yBottom);
	}
	void ZoomToSelection()
	{
		InvokeHelper(0x31, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoZoomWithinRect()
	{
		InvokeHelper(0x32, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoShowPagePropDlg()
	{
		InvokeHelper(0x33, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoShowHeaderAndFooterDlg()
	{
		InvokeHelper(0x34, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoShowTextDlg()
	{
		InvokeHelper(0x35, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoShowBulletsDlg()
	{
		InvokeHelper(0x36, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoShowLineDlg()
	{
		InvokeHelper(0x37, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoShowFillDlg()
	{
		InvokeHelper(0x38, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoShowShadowDlg()
	{
		InvokeHelper(0x39, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoShowEventDlg()
	{
		InvokeHelper(0x3a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoShowCustomDlg()
	{
		InvokeHelper(0x3b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawSelect()
	{
		InvokeHelper(0x3c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawLine()
	{
		InvokeHelper(0x3d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawArrowLine()
	{
		InvokeHelper(0x3e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawCrossLine()
	{
		InvokeHelper(0x3f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawArrowBezierLine()
	{
		InvokeHelper(0x40, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawDimLine()
	{
		InvokeHelper(0x41, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawFreeLine()
	{
		InvokeHelper(0x42, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawFreeCloseLine()
	{
		InvokeHelper(0x43, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawPolyLine()
	{
		InvokeHelper(0x44, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawPolygon()
	{
		InvokeHelper(0x45, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawEllipse()
	{
		InvokeHelper(0x46, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawRectangle()
	{
		InvokeHelper(0x47, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawRoundRect()
	{
		InvokeHelper(0x48, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawCloseBezier()
	{
		InvokeHelper(0x49, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawBezierLine()
	{
		InvokeHelper(0x4a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawStatic()
	{
		InvokeHelper(0x4b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawButton()
	{
		InvokeHelper(0x4c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDoDrawImage()
	{
		InvokeHelper(0x4d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawPort()
	{
		InvokeHelper(0x4e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DrawCustomRect(long nType)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x4f, DISPATCH_METHOD, VT_EMPTY, NULL, parms, nType);
	}
	void DoDrawLinkNormal()
	{
		InvokeHelper(0x50, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawLinkUpRight()
	{
		InvokeHelper(0x51, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawCornerLink()
	{
		InvokeHelper(0x52, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawBezierLink()
	{
		InvokeHelper(0x53, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoRotate()
	{
		InvokeHelper(0x54, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoRotateLeft()
	{
		InvokeHelper(0x55, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoRotateRight()
	{
		InvokeHelper(0x56, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoFlipHorz()
	{
		InvokeHelper(0x57, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoFlipVert()
	{
		InvokeHelper(0x58, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void RotateAngle(long nAngle)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x59, DISPATCH_METHOD, VT_EMPTY, NULL, parms, nAngle);
	}
	long GetRotateShapeCount()
	{
		long result;
		InvokeHelper(0x5a, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	void Group()
	{
		InvokeHelper(0x5b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void UnGroup()
	{
		InvokeHelper(0x5c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL EnableUnGroup()
	{
		BOOL result;
		InvokeHelper(0x5d, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void DoAlignLeft()
	{
		InvokeHelper(0x5e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoAlignRight()
	{
		InvokeHelper(0x5f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoAlignTop()
	{
		InvokeHelper(0x60, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoAlignBottom()
	{
		InvokeHelper(0x61, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoAlignCenter()
	{
		InvokeHelper(0x62, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoAlignVcenter()
	{
		InvokeHelper(0x63, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoAlignInviewHor()
	{
		InvokeHelper(0x64, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoAlignInviewVer()
	{
		InvokeHelper(0x65, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoSpaceAcross()
	{
		InvokeHelper(0x66, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoSpaceDown()
	{
		InvokeHelper(0x67, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoSizeWidth()
	{
		InvokeHelper(0x68, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoSizeHeight()
	{
		InvokeHelper(0x69, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoSizeAll()
	{
		InvokeHelper(0x6a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoLockcomp()
	{
		InvokeHelper(0x6b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoUnlockcomp()
	{
		InvokeHelper(0x6c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoMoveForward()
	{
		InvokeHelper(0x6d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoMoveBack()
	{
		InvokeHelper(0x6e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoMoveBackward()
	{
		InvokeHelper(0x6f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoCmdNudgeleft()
	{
		InvokeHelper(0x70, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoCmdNudgeright()
	{
		InvokeHelper(0x71, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoCmdNudgetop()
	{
		InvokeHelper(0x72, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoCmdNudgebottom()
	{
		InvokeHelper(0x73, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoCmdAutoPan()
	{
		InvokeHelper(0x74, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	long GetTotalSelect()
	{
		long result;
		InvokeHelper(0x75, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	void DoEditSpot()
	{
		InvokeHelper(0x76, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void ClearSelectionHandles()
	{
		InvokeHelper(0x77, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void RestoreSelectionHandles()
	{
		InvokeHelper(0x78, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void UpdateSelection()
	{
		InvokeHelper(0x79, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void UpdateScrollSize()
	{
		InvokeHelper(0x7a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoTabOrder()
	{
		InvokeHelper(0x7b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void SetModifiedFlag(BOOL bFlag)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x7c, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bFlag);
	}
	BOOL GetModifiedFlag()
	{
		BOOL result;
		InvokeHelper(0x7d, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	long HitTest(long xPoint, long yPoint)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x7e, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xPoint, yPoint);
		return result;
	}
	long HitTestPort(long xPoint, long yPoint)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x7f, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xPoint, yPoint);
		return result;
	}
	long GetCompsCount()
	{
		long result;
		InvokeHelper(0x80, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	void SetPagePosition(long xLeft, long yTop, long xRight, long yBottom)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x81, DISPATCH_METHOD, VT_EMPTY, NULL, parms, xLeft, yTop, xRight, yBottom);
	}
	void ChangePositionWithPages(long nHorzPages, long nVertPages)
	{
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x82, DISPATCH_METHOD, VT_EMPTY, NULL, parms, nHorzPages, nVertPages);
	}
	void SetLockWithPages(BOOL bLock)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x83, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bLock);
	}
	unsigned long GetGridColor()
	{
		unsigned long result;
		InvokeHelper(0x84, DISPATCH_METHOD, VT_UI4, (void*)&result, NULL);
		return result;
	}
	void SetGridColor(long crColor)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x85, DISPATCH_METHOD, VT_EMPTY, NULL, parms, crColor);
	}
	long GetGridX()
	{
		long result;
		InvokeHelper(0x86, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	void SetGridX(long nValue)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x87, DISPATCH_METHOD, VT_EMPTY, NULL, parms, nValue);
	}
	long GetGridY()
	{
		long result;
		InvokeHelper(0x88, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	void SetGridY(long nValue)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x89, DISPATCH_METHOD, VT_EMPTY, NULL, parms, nValue);
	}
	long GetBkColor()
	{
		long result;
		InvokeHelper(0x8a, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	void SetBkColor(long crColor)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x8b, DISPATCH_METHOD, VT_EMPTY, NULL, parms, crColor);
	}
	long GetPageBkColor()
	{
		long result;
		InvokeHelper(0x8c, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	void SetPageBkColor(long crColor)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x8d, DISPATCH_METHOD, VT_EMPTY, NULL, parms, crColor);
	}
	long GetBrushType()
	{
		long result;
		InvokeHelper(0x8e, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	void SetBrushType(short nType)
	{
		static BYTE parms[] = VTS_I2;
		InvokeHelper(0x8f, DISPATCH_METHOD, VT_EMPTY, NULL, parms, nType);
	}
	long GetPatternColor()
	{
		long result;
		InvokeHelper(0x90, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	void SetPatternColor(long crColor)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x91, DISPATCH_METHOD, VT_EMPTY, NULL, parms, crColor);
	}
	BOOL IsFormMode()
	{
		BOOL result;
		InvokeHelper(0x92, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void SetFormMode(BOOL bForm)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x93, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bForm);
	}
	long GetCommandState()
	{
		long result;
		InvokeHelper(0x94, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	BOOL CanUndo()
	{
		BOOL result;
		InvokeHelper(0x95, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	BOOL CanRedo()
	{
		BOOL result;
		InvokeHelper(0x96, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	BOOL CanPaste()
	{
		BOOL result;
		InvokeHelper(0x97, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	long GetGridStyle()
	{
		long result;
		InvokeHelper(0x98, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	void SetGridLineType(short nType)
	{
		static BYTE parms[] = VTS_I2;
		InvokeHelper(0x99, DISPATCH_METHOD, VT_EMPTY, NULL, parms, nType);
	}
	void DoPrintPreview(LPDISPATCH frm)
	{
		static BYTE parms[] = VTS_DISPATCH;
		InvokeHelper(0x9a, DISPATCH_METHOD, VT_EMPTY, NULL, parms, frm);
	}
	void PrintDraw()
	{
		InvokeHelper(0x9b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void ChangeModelBoolProp(BOOL bValue, long nPropID)
	{
		static BYTE parms[] = VTS_BOOL VTS_I4;
		InvokeHelper(0x9c, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bValue, nPropID);
	}
	void ChangeModelStringProp(LPCTSTR strValue, long nPropID)
	{
		static BYTE parms[] = VTS_BSTR VTS_I4;
		InvokeHelper(0x9d, DISPATCH_METHOD, VT_EMPTY, NULL, parms, strValue, nPropID);
	}
	void ChangeModelIntProp(long nValue, long nPropID)
	{
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x9e, DISPATCH_METHOD, VT_EMPTY, NULL, parms, nValue, nPropID);
	}
	void ChangeModelUINTProp(long nValue, long nPropID)
	{
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x9f, DISPATCH_METHOD, VT_EMPTY, NULL, parms, nValue, nPropID);
	}
	void ChangeModelFloatProp(float fValue, long nPropID)
	{
		static BYTE parms[] = VTS_R4 VTS_I4;
		InvokeHelper(0xa0, DISPATCH_METHOD, VT_EMPTY, NULL, parms, fValue, nPropID);
	}
	void ChangeModelDoubleProp(double dValue, long nPropID)
	{
		static BYTE parms[] = VTS_R8 VTS_I4;
		InvokeHelper(0xa1, DISPATCH_METHOD, VT_EMPTY, NULL, parms, dValue, nPropID);
	}
	void ChangeModelDateTimeProp(DATE dtValue, long nPropID)
	{
		static BYTE parms[] = VTS_DATE VTS_I4;
		InvokeHelper(0xa2, DISPATCH_METHOD, VT_EMPTY, NULL, parms, dtValue, nPropID);
	}
	void ChangeModelColorProp(long crValue, long nPropID)
	{
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0xa3, DISPATCH_METHOD, VT_EMPTY, NULL, parms, crValue, nPropID);
	}
	void ChangeModelDWordProp(long dwValue, short nPropID)
	{
		static BYTE parms[] = VTS_I4 VTS_I2;
		InvokeHelper(0xa4, DISPATCH_METHOD, VT_EMPTY, NULL, parms, dwValue, nPropID);
	}
	void ChangeSingleShapeBoolProp(long shape, BOOL bValue, long nPropID)
	{
		static BYTE parms[] = VTS_I4 VTS_BOOL VTS_I4;
		InvokeHelper(0xa5, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, bValue, nPropID);
	}
	void ChangeSingleShapeStringProp(long shape, LPCTSTR strValue, long nPropID)
	{
		static BYTE parms[] = VTS_I4 VTS_BSTR VTS_I4;
		InvokeHelper(0xa6, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, strValue, nPropID);
	}
	void ChangeSingleShapeIntProp(long shape, long nValue, long nPropID)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0xa7, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, nValue, nPropID);
	}
	void ChangeSingleShapeUINTProp(long shape, long nValue, long nPropID)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0xa8, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, nValue, nPropID);
	}
	void ChangeSingleShapeFloatProp(long shape, float fValue, long nPropID)
	{
		static BYTE parms[] = VTS_I4 VTS_R4 VTS_I4;
		InvokeHelper(0xa9, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, fValue, nPropID);
	}
	void ChangeSingleShapeDoubleProp(long shape, double dValue, long nPropID)
	{
		static BYTE parms[] = VTS_I4 VTS_R8 VTS_I4;
		InvokeHelper(0xaa, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, dValue, nPropID);
	}
	void ChangeSingleShapeDateTimeProp(long shape, DATE dtValue, long nPropID)
	{
		static BYTE parms[] = VTS_I4 VTS_DATE VTS_I4;
		InvokeHelper(0xab, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, dtValue, nPropID);
	}
	void ChangeSingleShapeColorProp(long shape, long crValue, long nPropID)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0xac, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, crValue, nPropID);
	}
	void ChangeSingleShapeDWordProp(long shape, long dwValue, long nPropID)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0xad, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, dwValue, nPropID);
	}
	void ChangeSelectionBoolProp(BOOL bValue, long nPropID)
	{
		static BYTE parms[] = VTS_BOOL VTS_I4;
		InvokeHelper(0xae, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bValue, nPropID);
	}
	void ChangeSelectionStringProp(LPCTSTR strValue, long nPropID)
	{
		static BYTE parms[] = VTS_BSTR VTS_I4;
		InvokeHelper(0xaf, DISPATCH_METHOD, VT_EMPTY, NULL, parms, strValue, nPropID);
	}
	void ChangeSelectionIntProp(long nValue, long nPropID)
	{
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0xb0, DISPATCH_METHOD, VT_EMPTY, NULL, parms, nValue, nPropID);
	}
	void ChangeSelectionUINTProp(long nValue, long nPropID)
	{
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0xb1, DISPATCH_METHOD, VT_EMPTY, NULL, parms, nValue, nPropID);
	}
	void ChangeSelectionFloatProp(float fValue, long nPropID)
	{
		static BYTE parms[] = VTS_R4 VTS_I4;
		InvokeHelper(0xb2, DISPATCH_METHOD, VT_EMPTY, NULL, parms, fValue, nPropID);
	}
	void ChangeSelectionDoubleProp(double dValue, long nPropID)
	{
		static BYTE parms[] = VTS_R8 VTS_I4;
		InvokeHelper(0xb3, DISPATCH_METHOD, VT_EMPTY, NULL, parms, dValue, nPropID);
	}
	void ChangeSelectionDateTimeProp(DATE dtValue, long nPropID)
	{
		static BYTE parms[] = VTS_DATE VTS_I4;
		InvokeHelper(0xb4, DISPATCH_METHOD, VT_EMPTY, NULL, parms, dtValue, nPropID);
	}
	void ChangeSelectionColorProp(long crValue, long nPropID)
	{
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0xb5, DISPATCH_METHOD, VT_EMPTY, NULL, parms, crValue, nPropID);
	}
	void ChangeSelectionDWordProp(long dwValue, long nPropID)
	{
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0xb6, DISPATCH_METHOD, VT_EMPTY, NULL, parms, dwValue, nPropID);
	}
	void AddUserData(long shape, long dwData)
	{
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0xb7, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, dwData);
	}
	long GetUserData(long shape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0xb8, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape);
		return result;
	}
	void MoveShape(long shape, long nxOffset, long nyOffset)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0xb9, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, nxOffset, nyOffset);
	}
	void ResizeShape(long shape, double dScaleX, double dScaleY, double dOX, double dOY)
	{
		static BYTE parms[] = VTS_I4 VTS_R8 VTS_R8 VTS_R8 VTS_R8;
		InvokeHelper(0xba, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, dScaleX, dScaleY, dOX, dOY);
	}
	void RotateShape(long shape, long nAngle, double dOX, double dOY)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_R8 VTS_R8;
		InvokeHelper(0xbb, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, nAngle, dOX, dOY);
	}
	void PositionShape(long shape, long xLeft, long yTop, long xRight, long yBottom)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0xbc, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, xLeft, yTop, xRight, yBottom);
	}
	long GetCurrentSelectShape()
	{
		long result;
		InvokeHelper(0xbd, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long FindShapeByCaption(LPCTSTR lpszCaption)
	{
		long result;
		static BYTE parms[] = VTS_BSTR;
		InvokeHelper(0xbe, DISPATCH_METHOD, VT_I4, (void*)&result, parms, lpszCaption);
		return result;
	}
	long FindShapeByName(LPCTSTR lpszName)
	{
		long result;
		static BYTE parms[] = VTS_BSTR;
		InvokeHelper(0xbf, DISPATCH_METHOD, VT_I4, (void*)&result, parms, lpszName);
		return result;
	}
	void DoPageSetup()
	{
		InvokeHelper(0xc0, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsEditSpots()
	{
		BOOL result;
		InvokeHelper(0xc1, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void DoShowCompsSelectDlg()
	{
		InvokeHelper(0xc2, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	long GetTotalGroupShapes()
	{
		long result;
		InvokeHelper(0xc3, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	void DoMoveFront()
	{
		InvokeHelper(0xc4, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsTabOrder()
	{
		BOOL result;
		InvokeHelper(0xc5, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	long GetDrawType()
	{
		long result;
		InvokeHelper(0xc6, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	void DoDrawCustomShapeID(long nResId)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0xc7, DISPATCH_METHOD, VT_EMPTY, NULL, parms, nResId);
	}
	void DoDrawCustomShapeFile(LPCTSTR lpszResFile)
	{
		static BYTE parms[] = VTS_BSTR;
		InvokeHelper(0xc8, DISPATCH_METHOD, VT_EMPTY, NULL, parms, lpszResFile);
	}
	void UpdateAllShapes()
	{
		InvokeHelper(0xc9, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void UpdateCanvas()
	{
		InvokeHelper(0xca, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawTable()
	{
		InvokeHelper(0xcb, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawArcLine()
	{
		InvokeHelper(0xcc, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawPie()
	{
		InvokeHelper(0xcd, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoShowPanWnd()
	{
		InvokeHelper(0xce, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsPanWndShow()
	{
		BOOL result;
		InvokeHelper(0xcf, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void EnableDisappearHandle(BOOL bEnable)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0xd0, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bEnable);
	}
	BOOL IsEnablePickNearest()
	{
		BOOL result;
		InvokeHelper(0xd1, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void EnablePickNearest(BOOL bEnable)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0xd2, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bEnable);
	}
	BOOL IsAngleSnapEnabled()
	{
		BOOL result;
		InvokeHelper(0xd3, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void EnableAngleSnap(BOOL bEnable)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0xd4, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bEnable);
	}
	void SetSnapAngle(long nWink)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0xd5, DISPATCH_METHOD, VT_EMPTY, NULL, parms, nWink);
	}
	long GetSnapAngle()
	{
		long result;
		InvokeHelper(0xd6, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	void SetPrimarySelectionColor(long crColor)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0xd7, DISPATCH_METHOD, VT_EMPTY, NULL, parms, crColor);
	}
	void SetSecondarySelectionColor(long crColor)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0xd8, DISPATCH_METHOD, VT_EMPTY, NULL, parms, crColor);
	}
	void AddShapePort(double dScaleX, double dScaleY)
	{
		static BYTE parms[] = VTS_R8 VTS_R8;
		InvokeHelper(0xd9, DISPATCH_METHOD, VT_EMPTY, NULL, parms, dScaleX, dScaleY);
	}
	void DoDrawMultiSelect()
	{
		InvokeHelper(0xda, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	long AddArcLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
		InvokeHelper(0xdb, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xStart, yStart, xEnd, yEnd, nWidth, bArrow);
		return result;
	}
	long AddTabShape(long nLeft, long nTop, long nRight, long nBottom, long nRows, long nCols, BOOL bFixRows, BOOL bFixCols, BOOL bShowGridLine)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL VTS_BOOL VTS_BOOL;
		InvokeHelper(0xdc, DISPATCH_METHOD, VT_I4, (void*)&result, parms, nLeft, nTop, nRight, nBottom, nRows, nCols, bFixRows, bFixCols, bShowGridLine);
		return result;
	}
	BOOL IsMultiSelectMode()
	{
		BOOL result;
		InvokeHelper(0xdd, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	long AddPieShape(long xStart, long yStart, long xEnd, long yEnd, long ptXStart, long ptYStart, long ptXEnd, long ptYEnd)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0xde, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xStart, yStart, xEnd, yEnd, ptXStart, ptYStart, ptXEnd, ptYEnd);
		return result;
	}
	long AddEllipseChordShape(long xStart, long yStart, long xEnd, long yEnd, long ptXStart, long ptYStart, long ptXEnd, long ptYEnd)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0xdf, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xStart, yStart, xEnd, yEnd, ptXStart, ptYStart, ptXEnd, ptYEnd);
		return result;
	}
	long AddArcLine2Shape(long xStart, long yStart, long xEnd, long yEnd, long ptXStart, long ptYStart, long ptXEnd, long ptYEnd, BOOL bArrow)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
		InvokeHelper(0xe0, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xStart, yStart, xEnd, yEnd, ptXStart, ptYStart, ptXEnd, ptYEnd, bArrow);
		return result;
	}
	void SetHlpLineVisible(BOOL bVisible)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0xe1, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bVisible);
	}
	void DoDrawArcLine2()
	{
		InvokeHelper(0xe2, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawEllipseChord()
	{
		InvokeHelper(0xe3, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoMirrorFree()
	{
		InvokeHelper(0xe4, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoRemoveHlpLine()
	{
		InvokeHelper(0xe5, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoShowPosAndSizeDlg()
	{
		InvokeHelper(0xe6, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void ExportAsBitmapFile(LPCTSTR strFile)
	{
		static BYTE parms[] = VTS_BSTR;
		InvokeHelper(0xe7, DISPATCH_METHOD, VT_EMPTY, NULL, parms, strFile);
	}
	void ExportAsEMFFile(LPCTSTR strFile)
	{
		static BYTE parms[] = VTS_BSTR;
		InvokeHelper(0xe8, DISPATCH_METHOD, VT_EMPTY, NULL, parms, strFile);
	}
	long AddExtLineShape(long xStart, long yStart, long xEnd, long yEnd, BOOL bArrow)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
		InvokeHelper(0xe9, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xStart, yStart, xEnd, yEnd, bArrow);
		return result;
	}
	long AddHorzDimLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
		InvokeHelper(0xea, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xStart, yStart, xEnd, yEnd, nWidth, bArrow);
		return result;
	}
	long AddVertDimLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
		InvokeHelper(0xeb, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xStart, yStart, xEnd, yEnd, nWidth, bArrow);
		return result;
	}
	long AddRadiusDimLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
		InvokeHelper(0xec, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xStart, yStart, xEnd, yEnd, nWidth, bArrow);
		return result;
	}
	long AddCaptionShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, long nHeight, BOOL bArrow)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
		InvokeHelper(0xed, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xStart, yStart, xEnd, yEnd, nWidth, nHeight, bArrow);
		return result;
	}
	long AddRectCalloutShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, long nHeight)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0xee, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xStart, yStart, xEnd, yEnd, nWidth, nHeight);
		return result;
	}
	long AddRoundCalloutShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, long nHeight)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0xef, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xStart, yStart, xEnd, yEnd, nWidth, nHeight);
		return result;
	}
	long AddCloudCalloutShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, long nHeight)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0xf0, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xStart, yStart, xEnd, yEnd, nWidth, nHeight);
		return result;
	}
	BOOL IsHlpLineVisible()
	{
		BOOL result;
		InvokeHelper(0xf1, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	BOOL IsEnableSnapToHelpLine()
	{
		BOOL result;
		InvokeHelper(0xf2, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void EnableSnapToHelpLine(BOOL bEnable)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0xf3, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bEnable);
	}
	BOOL IsEnableSnapToControlHandle()
	{
		BOOL result;
		InvokeHelper(0xf4, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void EnableSnapToControlHandle(BOOL bEnable)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0xf5, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bEnable);
	}
	BOOL IsEnableSnapToSpot()
	{
		BOOL result;
		InvokeHelper(0xf6, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void EnableSnapToSpot(BOOL bEnable)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0xf7, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bEnable);
	}
	BOOL IsEnableSnapToIntersectPoint()
	{
		BOOL result;
		InvokeHelper(0xf8, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void EnableSnapToIntersectPoint(BOOL bEnable)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0xf9, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bEnable);
	}
	BOOL IsCenterDrawAllowed()
	{
		BOOL result;
		InvokeHelper(0xfa, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void EnableCenterDraw(BOOL bEnable)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0xfb, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bEnable);
	}
	void DoDrawCaptionline()
	{
		InvokeHelper(0xfc, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawRectCallout()
	{
		InvokeHelper(0xfd, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawRoundCallout()
	{
		InvokeHelper(0xfe, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawCloudCallout()
	{
		InvokeHelper(0xff, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawHorzDimline()
	{
		InvokeHelper(0x100, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawVertDimline()
	{
		InvokeHelper(0x101, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawRadiusDimline()
	{
		InvokeHelper(0x102, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawExtLine()
	{
		InvokeHelper(0x103, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoReverseOrder()
	{
		InvokeHelper(0x104, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoInfrontShape()
	{
		InvokeHelper(0x105, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoBehindShape()
	{
		InvokeHelper(0x106, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsRulerVisible()
	{
		BOOL result;
		InvokeHelper(0x107, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void ShowRulers(BOOL bVisible)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x108, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bVisible);
	}
	void SetRulerUnit(short nType)
	{
		static BYTE parms[] = VTS_I2;
		InvokeHelper(0x109, DISPATCH_METHOD, VT_EMPTY, NULL, parms, nType);
	}
	void DoPutShapeToBack()
	{
		InvokeHelper(0x10a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoFoPolyInsertpoint()
	{
		InvokeHelper(0x10b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsAllowInsertPoint()
	{
		BOOL result;
		InvokeHelper(0x10c, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void DoFoPolyDeletepoint()
	{
		InvokeHelper(0x10d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsAllowDeletePoint()
	{
		BOOL result;
		InvokeHelper(0x10e, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void DoConvertSegmentToline()
	{
		InvokeHelper(0x10f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsAllowConvertSegmentToLine()
	{
		BOOL result;
		InvokeHelper(0x110, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void DoConvertSegmentToCurve()
	{
		InvokeHelper(0x111, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsAllowConvertSegmentToCurve()
	{
		BOOL result;
		InvokeHelper(0x112, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void DoRipUpPoint()
	{
		InvokeHelper(0x113, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsAllowRipUpPoint()
	{
		BOOL result;
		InvokeHelper(0x114, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void DoDrawTurnCornerLinkLine()
	{
		InvokeHelper(0x115, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawBreakCenterLinkLine()
	{
		InvokeHelper(0x116, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoEllipseSelect()
	{
		InvokeHelper(0x117, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoConvertToPath()
	{
		InvokeHelper(0x118, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsAllowConvertToPath()
	{
		BOOL result;
		InvokeHelper(0x119, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void DoConvertToPoly()
	{
		InvokeHelper(0x11a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsAllowConvertToPoly()
	{
		BOOL result;
		InvokeHelper(0x11b, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void DoShapesCombine()
	{
		InvokeHelper(0x11c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsAllowShapeCombine()
	{
		BOOL result;
		InvokeHelper(0x11d, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void DoShapesDismantle()
	{
		InvokeHelper(0x11e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsAllowShapeDismantle()
	{
		BOOL result;
		InvokeHelper(0x11f, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void DoShapesMergeMerge()
	{
		InvokeHelper(0x120, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsAllowShapeMergeMerge()
	{
		BOOL result;
		InvokeHelper(0x121, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void DoShapesMergeSubstract()
	{
		InvokeHelper(0x122, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsAllowShapeMergeSubstract()
	{
		BOOL result;
		InvokeHelper(0x123, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void DoShapesMergeIntersect()
	{
		InvokeHelper(0x124, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsAllowShapeMergeIntersect()
	{
		BOOL result;
		InvokeHelper(0x125, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void DoConnectLines()
	{
		InvokeHelper(0x126, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsAllowConnectLines()
	{
		BOOL result;
		InvokeHelper(0x127, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void DoBreakShapeToLines()
	{
		InvokeHelper(0x128, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsAllowBreakShapeToLines()
	{
		BOOL result;
		InvokeHelper(0x129, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void DoCloseShape()
	{
		InvokeHelper(0x12a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsAllowCloseShape()
	{
		BOOL result;
		InvokeHelper(0x12b, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void DoShearFree()
	{
		InvokeHelper(0x12c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsAllowShearFree()
	{
		BOOL result;
		InvokeHelper(0x12d, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	BOOL IsEllipseSelectMode()
	{
		BOOL result;
		InvokeHelper(0x12e, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void ConnectSelectShapes()
	{
		InvokeHelper(0x12f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoGenCreateLink()
	{
		InvokeHelper(0x130, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void AddToSelection(long shape)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x131, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape);
	}
	void RemoveShape(long shape)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x132, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape);
	}
	BOOL GetShapeBoolProp(long shape, long nPropID)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x133, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape, nPropID);
		return result;
	}
	CString GetShapeStringProp(long shape, long nPropID)
	{
		CString result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x134, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, shape, nPropID);
		return result;
	}
	long GetShapeIntProp(long shape, long nPropID)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x135, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape, nPropID);
		return result;
	}
	short GetShapeUINTProp(long shape, long nPropID)
	{
		short result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x136, DISPATCH_METHOD, VT_I2, (void*)&result, parms, shape, nPropID);
		return result;
	}
	float GetShapeFloatProp(long shape, long nPropID)
	{
		float result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x137, DISPATCH_METHOD, VT_R4, (void*)&result, parms, shape, nPropID);
		return result;
	}
	double GetShapeDoubleProp(long shape, long nPropID)
	{
		double result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x138, DISPATCH_METHOD, VT_R8, (void*)&result, parms, shape, nPropID);
		return result;
	}
	DATE GetShapeDateTimeProp(long shape, long nPropID)
	{
		DATE result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x139, DISPATCH_METHOD, VT_DATE, (void*)&result, parms, shape, nPropID);
		return result;
	}
	long GetShapeColorProp(long shape, long nPropID)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x13a, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape, nPropID);
		return result;
	}
	long GetShapeDwordProp(long shape, long nPropID)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x13b, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape, nPropID);
		return result;
	}
	long ConnectTwoShapes(long shapefirst, long shapesecond)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x13c, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shapefirst, shapesecond);
		return result;
	}
	BOOL IsStaticShape(long shape)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x13d, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape);
		return result;
	}
	BOOL IsShapeLinked(long shape)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x13e, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape);
		return result;
	}
	long GetBoundXPos(long shape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x13f, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape);
		return result;
	}
	long GetBoundYPos(long shape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x140, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape);
		return result;
	}
	long GetBoundWidth(long shape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x141, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape);
		return result;
	}
	long GetBoundHeight(long shape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x142, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape);
		return result;
	}
	long GetSnapXPos(long shape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x143, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape);
		return result;
	}
	long GetSnapYPos(long shape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x144, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape);
		return result;
	}
	long GetSnapWidth(long shape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x145, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape);
		return result;
	}
	long GetSnapHeight(long shape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x146, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape);
		return result;
	}
	BOOL IsPolyObject(long shape)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x147, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape);
		return result;
	}
	void SetInitRotateAngle(long shape, long angle)
	{
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x148, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, angle);
	}
	void UpdateComp(long shape)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x149, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape);
	}
	BOOL IsShapeClosed(long shape)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x14a, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape);
		return result;
	}
	void SetWithLabelShow(long shape, BOOL allow)
	{
		static BYTE parms[] = VTS_I4 VTS_BOOL;
		InvokeHelper(0x14b, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, allow);
	}
	void SetWithLabelEditing(long shape, BOOL allow)
	{
		static BYTE parms[] = VTS_I4 VTS_BOOL;
		InvokeHelper(0x14c, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, allow);
	}
	BOOL IsLinkShape(long shape)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x14d, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape);
		return result;
	}
	BOOL IsCompositeShape(long shape)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x14e, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape);
		return result;
	}
	BOOL IsGroupShape(long shape)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x14f, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape);
		return result;
	}
	BOOL IsKindShape(long shape, long Type)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x150, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape, Type);
		return result;
	}
	long GetSelectionCount()
	{
		long result;
		InvokeHelper(0x151, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long GetSelection(long index)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x152, DISPATCH_METHOD, VT_I4, (void*)&result, parms, index);
		return result;
	}
	long GetShapeAt(long index)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x153, DISPATCH_METHOD, VT_I4, (void*)&result, parms, index);
		return result;
	}
	long GetCompositeShapeChildCount(long shapecomposite)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x154, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shapecomposite);
		return result;
	}
	long GetCompositeShapeAt(long compositeshape, long index)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x155, DISPATCH_METHOD, VT_I4, (void*)&result, parms, compositeshape, index);
		return result;
	}
	long GetPortsShapePortCount(long portsshape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x156, DISPATCH_METHOD, VT_I4, (void*)&result, parms, portsshape);
		return result;
	}
	long GetPortsShapePortShapeAt(long portsshape, long index)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x157, DISPATCH_METHOD, VT_I4, (void*)&result, parms, portsshape, index);
		return result;
	}
	long GetPortLinkCount(long portshape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x158, DISPATCH_METHOD, VT_I4, (void*)&result, parms, portshape);
		return result;
	}
	long GetPortLinkShapeAt(long portshape, long index)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x159, DISPATCH_METHOD, VT_I4, (void*)&result, parms, portshape, index);
		return result;
	}
	long GetLinkFromShape(long link)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x15a, DISPATCH_METHOD, VT_I4, (void*)&result, parms, link);
		return result;
	}
	long GetLinkToShape(long link)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x15b, DISPATCH_METHOD, VT_I4, (void*)&result, parms, link);
		return result;
	}
	void RemoveCurShapeToSelection(long shape)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x15c, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape);
	}
	BOOL IsShapeSelected(long shape)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x15d, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape);
		return result;
	}
	BOOL IsPortShape(long shape)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x15e, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape);
		return result;
	}
	long AddDefaultPort(long portsshape, double xScale, double yScale)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_R8 VTS_R8;
		InvokeHelper(0x15f, DISPATCH_METHOD, VT_I4, (void*)&result, parms, portsshape, xScale, yScale);
		return result;
	}
	long ConnectWithTwoPorts(long portFirst, long portSecond)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x160, DISPATCH_METHOD, VT_I4, (void*)&result, parms, portFirst, portSecond);
		return result;
	}
	void FlashShape(long shape, short times)
	{
		static BYTE parms[] = VTS_I4 VTS_I2;
		InvokeHelper(0x161, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, times);
	}
	long GetMaxUndoActionCount()
	{
		long result;
		InvokeHelper(0x162, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long GetMaxRedoActionCount()
	{
		long result;
		InvokeHelper(0x163, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	void SetMaxUndoActionCount(short Count)
	{
		static BYTE parms[] = VTS_I2;
		InvokeHelper(0x164, DISPATCH_METHOD, VT_EMPTY, NULL, parms, Count);
	}
	void SetMaxRedoActionCount(short Count)
	{
		static BYTE parms[] = VTS_I2;
		InvokeHelper(0x165, DISPATCH_METHOD, VT_EMPTY, NULL, parms, Count);
	}
	void ChangeRulerUnit(short unit)
	{
		static BYTE parms[] = VTS_I2;
		InvokeHelper(0x166, DISPATCH_METHOD, VT_EMPTY, NULL, parms, unit);
	}
	void SelectShape(long shape)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x167, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape);
	}
	long GetBackgroundShapeCount()
	{
		long result;
		InvokeHelper(0x168, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long GetBackShapeAt(long index)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x169, DISPATCH_METHOD, VT_I4, (void*)&result, parms, index);
		return result;
	}
	void AddShapeToBack(long shape)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x16a, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape);
	}
	void RemoveShapeFromBack(long shape)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x16b, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape);
	}
	void RemoveAllShapesFromBack()
	{
		InvokeHelper(0x16c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	long FindShapeWithNameFromBack(LPCTSTR Name)
	{
		long result;
		static BYTE parms[] = VTS_BSTR;
		InvokeHelper(0x16d, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Name);
		return result;
	}
	long CloneShape(long shape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x16e, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape);
		return result;
	}
	void RemoveAllPorts(long portsshape)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x16f, DISPATCH_METHOD, VT_EMPTY, NULL, parms, portsshape);
	}
	long GetShapePointCount(long shape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x170, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape);
		return result;
	}
	long GetShapePointXAt(long shape, long index)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x171, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape, index);
		return result;
	}
	long GetShapePointYAt(long shape, long index)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x172, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape, index);
		return result;
	}
	void AddShapePoint(long shape, long x, long y)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x173, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, x, y);
	}
	void RemoveShapePoint(long shape, long index)
	{
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x174, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, index);
	}
	void InsertShapePoint(long shape, long index, long x, long y)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x175, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, index, x, y);
	}
	void SetShapePointAt(long shape, long index, long x, long y)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x176, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, index, x, y);
	}
	BOOL IsToolBoxVisible()
	{
		BOOL result;
		InvokeHelper(0x177, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void ShowToolBoxWindow(BOOL bShow)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x178, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bShow);
	}
	void RomoveToolBoxPage(long index)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x179, DISPATCH_METHOD, VT_EMPTY, NULL, parms, index);
	}
	long GetToolBoxPageCount()
	{
		long result;
		InvokeHelper(0x17a, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	void EnableToolboxEditProp(BOOL bEnable)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x17b, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bEnable);
	}
	long FODPtoLPX(long xInput)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x17c, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xInput);
		return result;
	}
	long FODPtoLPY(long yInput)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x17d, DISPATCH_METHOD, VT_I4, (void*)&result, parms, yInput);
		return result;
	}
	long FOLPtoDPX(long xInput)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x17e, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xInput);
		return result;
	}
	long FOLPtoDPY(long yInput)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x17f, DISPATCH_METHOD, VT_I4, (void*)&result, parms, yInput);
		return result;
	}
	void EnableUniqueCaption(BOOL bEnable)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x180, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bEnable);
	}
	void EnableUniqueName(BOOL bEnable)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x181, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bEnable);
	}
	long GetPortParentShape(long portshape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x182, DISPATCH_METHOD, VT_I4, (void*)&result, parms, portshape);
		return result;
	}
	long CreateShape(short nType, long xLeft, long yTop, long xRight, long yBottom, LPCTSTR lpszFileName)
	{
		long result;
		static BYTE parms[] = VTS_I2 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR;
		InvokeHelper(0x183, DISPATCH_METHOD, VT_I4, (void*)&result, parms, nType, xLeft, yTop, xRight, yBottom, lpszFileName);
		return result;
	}
	void AddListField(long listshape, short index, BOOL bshowleftport, BOOL bshowrightport, LPCTSTR strfield)
	{
		static BYTE parms[] = VTS_I4 VTS_I2 VTS_BOOL VTS_BOOL VTS_BSTR;
		InvokeHelper(0x184, DISPATCH_METHOD, VT_EMPTY, NULL, parms, listshape, index, bshowleftport, bshowrightport, strfield);
	}
	void UpdateShapeGeo(long shape)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x185, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape);
	}
	long FindPortFromIndex(long listshape, short index, BOOL bLeftPort)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I2 VTS_BOOL;
		InvokeHelper(0x186, DISPATCH_METHOD, VT_I4, (void*)&result, parms, listshape, index, bLeftPort);
		return result;
	}
	long LinkTwoField(long FromPort, long ToPort)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x187, DISPATCH_METHOD, VT_I4, (void*)&result, parms, FromPort, ToPort);
		return result;
	}
	long GetFieldCountOfListCtrl(long listshape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x188, DISPATCH_METHOD, VT_I4, (void*)&result, parms, listshape);
		return result;
	}
	CString GetFieldCaption(long listshape, short index)
	{
		CString result;
		static BYTE parms[] = VTS_I4 VTS_I2;
		InvokeHelper(0x189, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, listshape, index);
		return result;
	}
	void DoDrawImageNode(LPDISPATCH iPictureDisp)
	{
		static BYTE parms[] = VTS_DISPATCH;
		InvokeHelper(0x18a, DISPATCH_METHOD, VT_EMPTY, NULL, parms, iPictureDisp);
	}
	long AddImageNode(long x, long y, LPDISPATCH iPictureDisp)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_DISPATCH;
		InvokeHelper(0x18b, DISPATCH_METHOD, VT_I4, (void*)&result, parms, x, y, iPictureDisp);
		return result;
	}
	void EnableContinueDraw(BOOL bEnable)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x18c, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bEnable);
	}
	void DoMakeSubgraph()
	{
		InvokeHelper(0x18d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void UnGroupSubgraph()
	{
		InvokeHelper(0x18e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoVCPrintPreview()
	{
		InvokeHelper(0x18f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void ChangeToolBoxBackColor(long crFirst, long crLast)
	{
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x190, DISPATCH_METHOD, VT_EMPTY, NULL, parms, crFirst, crLast);
	}
	BOOL GetModelBoolProp(long nPropID)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x191, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, nPropID);
		return result;
	}
	CString GetModelStringProp(long nPropID)
	{
		CString result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x192, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, nPropID);
		return result;
	}
	long GetModelIntProp(long nPropID)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x193, DISPATCH_METHOD, VT_I4, (void*)&result, parms, nPropID);
		return result;
	}
	float GetModelFloatProp(long nPropID)
	{
		float result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x194, DISPATCH_METHOD, VT_R4, (void*)&result, parms, nPropID);
		return result;
	}
	double GetModelDoubleProp(long nPropID)
	{
		double result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x195, DISPATCH_METHOD, VT_R8, (void*)&result, parms, nPropID);
		return result;
	}
	DATE GetModelDateTimeProp(long nPropID)
	{
		DATE result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x196, DISPATCH_METHOD, VT_DATE, (void*)&result, parms, nPropID);
		return result;
	}
	long GetModelColorProp(float nPropID)
	{
		long result;
		static BYTE parms[] = VTS_R4;
		InvokeHelper(0x197, DISPATCH_METHOD, VT_I4, (void*)&result, parms, nPropID);
		return result;
	}
	long GetModelDWordProp(long nPropID)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x198, DISPATCH_METHOD, VT_I4, (void*)&result, parms, nPropID);
		return result;
	}
	void DoDrawEllipse2()
	{
		InvokeHelper(0x199, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	long AddEllipse2Shape(long xLeft, long yTop, long xRight, long yBottom, LPCTSTR lpszCaption)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR;
		InvokeHelper(0x19a, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xLeft, yTop, xRight, yBottom, lpszCaption);
		return result;
	}
	void DoDrawNewBizerLine()
	{
		InvokeHelper(0x19b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void EnterEditingBack()
	{
		InvokeHelper(0x19c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void EndEditingBack()
	{
		InvokeHelper(0x19d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL IsModified()
	{
		BOOL result;
		InvokeHelper(0x19e, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void DoAutoReroute()
	{
		InvokeHelper(0x19f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	long AddSimplePathShape(long xStart, long yStart, long xEnd, long yEnd, short nType)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I2;
		InvokeHelper(0x1a0, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xStart, yStart, xEnd, yEnd, nType);
		return result;
	}
	void EnableFreeFormDrawing(BOOL bEnable)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x1a1, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bEnable);
	}
	BOOL IsFreeFormDrawing()
	{
		BOOL result;
		InvokeHelper(0x1a2, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	BOOL IsEnableSnapDynGrid()
	{
		BOOL result;
		InvokeHelper(0x1a3, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void EnableSnapDynGrid(BOOL bEnable)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x1a4, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bEnable);
	}
	void EnableSnapAidLine(BOOL bEnable)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x1a5, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bEnable);
	}
	BOOL IsEnableSnapAidLine()
	{
		BOOL result;
		InvokeHelper(0x1a6, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	void ShowColorThemeDlg()
	{
		InvokeHelper(0x1a7, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawCurveLink()
	{
		InvokeHelper(0x1a8, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void DoDrawRoundCornerLinkLine()
	{
		InvokeHelper(0x1a9, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void MoveShapeTo(long shape, long xPos, long yPos)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x1aa, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, xPos, yPos);
	}
	void SetShapeDimension(long shape, long Width, long Height)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x1ab, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, Width, Height);
	}
	BOOL GetShapeShowLabelAtFirst(long shape)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1ac, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape);
		return result;
	}
	void SetShapeShowLabelAtFirst(long shape, BOOL bShow)
	{
		static BYTE parms[] = VTS_I4 VTS_BOOL;
		InvokeHelper(0x1ad, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, bShow);
	}
	BOOL GetShapeWithLabelShow(long shape)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1ae, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape);
		return result;
	}
	void SetShapeWithLabelShow(long shape, BOOL bShow)
	{
		static BYTE parms[] = VTS_I4 VTS_BOOL;
		InvokeHelper(0x1af, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, bShow);
	}
	BOOL GetShapeWithLabelEditing(long shape)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1b0, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape);
		return result;
	}
	void SetShapeWithLabelEditing(long shape, BOOL bEnable)
	{
		static BYTE parms[] = VTS_I4 VTS_BOOL;
		InvokeHelper(0x1b1, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, bEnable);
	}
	void MPreparePtAry()
	{
		InvokeHelper(0x1b2, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void MAddPtToAry(long xPoint, long yPoint)
	{
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x1b3, DISPATCH_METHOD, VT_EMPTY, NULL, parms, xPoint, yPoint);
	}
	long AddPolylineShape(LPCTSTR strCaption)
	{
		long result;
		static BYTE parms[] = VTS_BSTR;
		InvokeHelper(0x1b4, DISPATCH_METHOD, VT_I4, (void*)&result, parms, strCaption);
		return result;
	}
	long MAddPolygonShape(LPCTSTR strCaption)
	{
		long result;
		static BYTE parms[] = VTS_BSTR;
		InvokeHelper(0x1b5, DISPATCH_METHOD, VT_I4, (void*)&result, parms, strCaption);
		return result;
	}
	long MAddBezierLineShape(LPCTSTR strCaption)
	{
		long result;
		static BYTE parms[] = VTS_BSTR;
		InvokeHelper(0x1b6, DISPATCH_METHOD, VT_I4, (void*)&result, parms, strCaption);
		return result;
	}
	long MAddCloseBezierLineShape(LPCTSTR strCaption)
	{
		long result;
		static BYTE parms[] = VTS_BSTR;
		InvokeHelper(0x1b7, DISPATCH_METHOD, VT_I4, (void*)&result, parms, strCaption);
		return result;
	}
	long MAddExtBezierLineShape(LPCTSTR strCaption)
	{
		long result;
		static BYTE parms[] = VTS_BSTR;
		InvokeHelper(0x1b8, DISPATCH_METHOD, VT_I4, (void*)&result, parms, strCaption);
		return result;
	}
	void MAddLinkShape(short nLinkType, long FromPort, long ToPort, short arrowtype)
	{
		static BYTE parms[] = VTS_I2 VTS_I4 VTS_I4 VTS_I2;
		InvokeHelper(0x1b9, DISPATCH_METHOD, VT_EMPTY, NULL, parms, nLinkType, FromPort, ToPort, arrowtype);
	}
	long GetShapeCenterPort(long shape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1ba, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape);
		return result;
	}
	void SetApplicationName(LPCTSTR pszAppName)
	{
		static BYTE parms[] = VTS_BSTR;
		InvokeHelper(0x1bb, DISPATCH_METHOD, VT_EMPTY, NULL, parms, pszAppName);
	}
	BOOL FindShapeWithinDataModel(long shape)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1bc, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape);
		return result;
	}
	BOOL AddBoolUserProperty(long shape, long nPropID, BOOL bValue)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_BOOL;
		InvokeHelper(0x1bd, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape, nPropID, bValue);
		return result;
	}
	BOOL AddStringUserProperty(long shape, long nPropID, LPCTSTR strValue)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_BSTR;
		InvokeHelper(0x1be, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape, nPropID, strValue);
		return result;
	}
	BOOL AddIntUserProperty(long shape, long nPropID, long nValue)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x1bf, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape, nPropID, nValue);
		return result;
	}
	BOOL AddFloatUserProperty(long shape, long nPropID, float fValue)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_R4;
		InvokeHelper(0x1c0, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape, nPropID, fValue);
		return result;
	}
	BOOL AddDoubleUserProperty(long shape, long nPropID, double dValue)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_R8;
		InvokeHelper(0x1c1, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape, nPropID, dValue);
		return result;
	}
	BOOL AddDateUserProperty(long shape, long nPropID, DATE dtTime)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_DATE;
		InvokeHelper(0x1c2, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape, nPropID, dtTime);
		return result;
	}
	BOOL AddColorUserProperty(long shape, long nPropID, long crColor)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x1c3, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape, nPropID, crColor);
		return result;
	}
	BOOL AddDWordUserProperty(long shape, long nPropID, long dwData)
	{
		BOOL result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x1c4, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, shape, nPropID, dwData);
		return result;
	}
	void ChangeShapeBoolWithoutUndo(long shape, long nPropID, BOOL bValue)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_BOOL;
		InvokeHelper(0x1c5, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, nPropID, bValue);
	}
	void ChangeShapeStringWithoutUndo(long shape, long nPropID, LPCTSTR strValue)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_BSTR;
		InvokeHelper(0x1c6, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, nPropID, strValue);
	}
	void ChangeShapeIntWithoutUndo(long shape, long nPropID, long nValue)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x1c7, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, nPropID, nValue);
	}
	void ChangeShapeFloatWithoutUndo(long shape, long nPropID, float fValue)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_R4;
		InvokeHelper(0x1c8, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, nPropID, fValue);
	}
	void ChangeShapeDoubleWithoutUndo(long shape, long nPropID, double dValue)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_R8;
		InvokeHelper(0x1c9, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, nPropID, dValue);
	}
	void ChangeShapeDWordWithoutUndo(long shape, long nPropID, long dwValue)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x1ca, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, nPropID, dwValue);
	}
	void ChangeShapeColorWithoutUndo(long shape, long nPropID, long crColor)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x1cb, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, nPropID, crColor);
	}
	void ChangeShapeDateWithoutUndo(long shape, long nPropID, DATE dtValue)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_DATE;
		InvokeHelper(0x1cc, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, nPropID, dtValue);
	}
	long GetLinkCount()
	{
		long result;
		InvokeHelper(0x1cd, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long GetLinkAt(long nIndex)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1ce, DISPATCH_METHOD, VT_I4, (void*)&result, parms, nIndex);
		return result;
	}
	long GetSelectedLinkCount()
	{
		long result;
		InvokeHelper(0x1cf, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long GetSelectedLinkAt(long index)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1d0, DISPATCH_METHOD, VT_I4, (void*)&result, parms, index);
		return result;
	}
	void RemoveShapeWithoutUndo(long shape)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1d1, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape);
	}
	long GetShapeLinksCount(long node)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1d2, DISPATCH_METHOD, VT_I4, (void*)&result, parms, node);
		return result;
	}
	long GetShapeLinksAtIndex(long node, long index)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x1d3, DISPATCH_METHOD, VT_I4, (void*)&result, parms, node, index);
		return result;
	}
	long GetShapeFromLinksCount(long shape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1d4, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape);
		return result;
	}
	long GetShapeFromLinksAtIndex(long node, long index)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x1d5, DISPATCH_METHOD, VT_I4, (void*)&result, parms, node, index);
		return result;
	}
	long GetShapeToLinksCount(long shape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1d6, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape);
		return result;
	}
	long GetShapeToLinksAtIndex(long node, long index)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x1d7, DISPATCH_METHOD, VT_I4, (void*)&result, parms, node, index);
		return result;
	}
	long GetDirectLinkedShapeCount(long node)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1d8, DISPATCH_METHOD, VT_I4, (void*)&result, parms, node);
		return result;
	}
	long GetDirectLinkedShapeAt(long node, long index)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x1d9, DISPATCH_METHOD, VT_I4, (void*)&result, parms, node, index);
		return result;
	}
	long GetDirectLinkedFromShapeCount(long node)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1da, DISPATCH_METHOD, VT_I4, (void*)&result, parms, node);
		return result;
	}
	long GetDirectLinkedFromShapeAt(long node, long index)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x1db, DISPATCH_METHOD, VT_I4, (void*)&result, parms, node, index);
		return result;
	}
	long GetDirectLinkedToShapeCount(long node)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1dc, DISPATCH_METHOD, VT_I4, (void*)&result, parms, node);
		return result;
	}
	long GetDirectLinkedToShapeAt(long node, long index)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x1dd, DISPATCH_METHOD, VT_I4, (void*)&result, parms, node, index);
		return result;
	}
	long GetAllLinkedShapeCount(long node)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1de, DISPATCH_METHOD, VT_I4, (void*)&result, parms, node);
		return result;
	}
	long GetAllLinkedShapeAt(long node, long index)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x1df, DISPATCH_METHOD, VT_I4, (void*)&result, parms, node, index);
		return result;
	}
	long GetAllLinkedFromShapeAt(long node, long index)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x1e0, DISPATCH_METHOD, VT_I4, (void*)&result, parms, node, index);
		return result;
	}
	long GetAllLinkedFromShapeCount(long node)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1e1, DISPATCH_METHOD, VT_I4, (void*)&result, parms, node);
		return result;
	}
	long GetAllLinkedToShapeCount(long node)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1e2, DISPATCH_METHOD, VT_I4, (void*)&result, parms, node);
		return result;
	}
	long GetAllLinkedToShapeAt(long node, long index)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x1e3, DISPATCH_METHOD, VT_I4, (void*)&result, parms, node, index);
		return result;
	}
	long GetFocusShape()
	{
		long result;
		InvokeHelper(0x1e4, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long AddLinkShapeNoUndo(long FromNode, long ToNode, short LinkType, short arrowtype)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I2 VTS_I2;
		InvokeHelper(0x1e5, DISPATCH_METHOD, VT_I4, (void*)&result, parms, FromNode, ToNode, LinkType, arrowtype);
		return result;
	}
	void ChangeToolBoxIndexFile(LPCTSTR strNewFile)
	{
		static BYTE parms[] = VTS_BSTR;
		InvokeHelper(0x1e6, DISPATCH_METHOD, VT_EMPTY, NULL, parms, strNewFile);
	}
	void DoShowProtDlg()
	{
		InvokeHelper(0x1e7, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	long SaveToImage()
	{
		long result;
		InvokeHelper(0x1e8, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long LoadFromImage(long hEmf, long xStart, long yStart)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x1e9, DISPATCH_METHOD, VT_I4, (void*)&result, parms, hEmf, xStart, yStart);
		return result;
	}
	void EndTextBoxEdit()
	{
		InvokeHelper(0x1ea, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void EndEditBoxEdit()
	{
		InvokeHelper(0x1eb, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void EndComboBoxEdit()
	{
		InvokeHelper(0x1ec, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void StartRichTextEdit(long richshape)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1ed, DISPATCH_METHOD, VT_EMPTY, NULL, parms, richshape);
	}
	long SaveMemory(long * xlen)
	{
		long result;
		static BYTE parms[] = VTS_PI4;
		InvokeHelper(0x1ee, DISPATCH_METHOD, VT_I4, (void*)&result, parms, xlen);
		return result;
	}
	void LoadMemory(long hMem, long * xlen)
	{
		static BYTE parms[] = VTS_I4 VTS_PI4;
		InvokeHelper(0x1ef, DISPATCH_METHOD, VT_EMPTY, NULL, parms, hMem, xlen);
	}
	BOOL SaveMemory2(LPCTSTR filename, long pData, long nSize)
	{
		BOOL result;
		static BYTE parms[] = VTS_BSTR VTS_I4 VTS_I4;
		InvokeHelper(0x1f0, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, filename, pData, nSize);
		return result;
	}
	long LoadMemory2(LPCTSTR filename, long lpData)
	{
		long result;
		static BYTE parms[] = VTS_BSTR VTS_I4;
		InvokeHelper(0x1f1, DISPATCH_METHOD, VT_I4, (void*)&result, parms, filename, lpData);
		return result;
	}
	void InsertOleShape()
	{
		InvokeHelper(0x1f2, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void SetCanvasSize(long szWidthPt, long szHeightPt)
	{
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x1f3, DISPATCH_METHOD, VT_EMPTY, NULL, parms, szWidthPt, szHeightPt);
	}
	long SaveDocument(LPWSTR lpszFileName)
	{
		long result;
		static BYTE parms[] = VTS_UNKNOWN;
		InvokeHelper(0x1f4, DISPATCH_METHOD, VT_I4, (void*)&result, parms, lpszFileName);
		return result;
	}
	long OpenDocument(LPWSTR lpszFileName)
	{
		long result;
		static BYTE parms[] = VTS_UNKNOWN;
		InvokeHelper(0x1f5, DISPATCH_METHOD, VT_I4, (void*)&result, parms, lpszFileName);
		return result;
	}
	void ShowToolBoxWindow2(long bShow)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1f6, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bShow);
	}
	void RomoveToolBoxPage2(long index)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1f7, DISPATCH_METHOD, VT_EMPTY, NULL, parms, index);
	}
	void UpdateAllWindows()
	{
		InvokeHelper(0x1f8, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	long GetShapeType(long shape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1f9, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape);
		return result;
	}
	CString GetCurrentText(long shape)
	{
		CString result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1fa, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, shape);
		return result;
	}
	void SetCurrentText(long shape, LPWSTR sText)
	{
		static BYTE parms[] = VTS_I4 VTS_UNKNOWN;
		InvokeHelper(0x1fb, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, sText);
	}
	long IsEFormShape(long shape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1fc, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape);
		return result;
	}
	long GetEFormFocusShape()
	{
		long result;
		InvokeHelper(0x1fd, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	void SetMarqueeShapeSpeed(long marqueeshape, short speedtime)
	{
		static BYTE parms[] = VTS_I4 VTS_I2;
		InvokeHelper(0x1fe, DISPATCH_METHOD, VT_EMPTY, NULL, parms, marqueeshape, speedtime);
	}
	void SetPointLimitWithPage(long bWithIn)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1ff, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bWithIn);
	}
	void UpdateControl(long shape)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x200, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape);
	}
	CString GetRunTimeInputText()
	{
		CString result;
		InvokeHelper(0x201, DISPATCH_METHOD, VT_BSTR, (void*)&result, NULL);
		return result;
	}
	void SetFocusOnShape(long shape)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x202, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape);
	}
	long ReadFromBlob(long hBlob, long lReservedBytes)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x203, DISPATCH_METHOD, VT_I4, (void*)&result, parms, hBlob, lReservedBytes);
		return result;
	}
	long WriteToBlob(long * phBlob, long lReservedBytes)
	{
		long result;
		static BYTE parms[] = VTS_PI4 VTS_I4;
		InvokeHelper(0x204, DISPATCH_METHOD, VT_I4, (void*)&result, parms, phBlob, lReservedBytes);
		return result;
	}
	long LoadXdgFromFile(LPWSTR lpszFileName)
	{
		long result;
		static BYTE parms[] = VTS_UNKNOWN;
		InvokeHelper(0x205, DISPATCH_METHOD, VT_I4, (void*)&result, parms, lpszFileName);
		return result;
	}
	void SaveToXdgFile(LPWSTR lpszFileName)
	{
		static BYTE parms[] = VTS_UNKNOWN;
		InvokeHelper(0x206, DISPATCH_METHOD, VT_EMPTY, NULL, parms, lpszFileName);
	}
	long FindShapeWithKey1(LPWSTR strKey)
	{
		long result;
		static BYTE parms[] = VTS_UNKNOWN;
		InvokeHelper(0x207, DISPATCH_METHOD, VT_I4, (void*)&result, parms, strKey);
		return result;
	}
	long FindShapeWithKey2(LPWSTR strKey)
	{
		long result;
		static BYTE parms[] = VTS_UNKNOWN;
		InvokeHelper(0x208, DISPATCH_METHOD, VT_I4, (void*)&result, parms, strKey);
		return result;
	}
	long FindShapeWithKey3(LPWSTR strKey)
	{
		long result;
		static BYTE parms[] = VTS_UNKNOWN;
		InvokeHelper(0x209, DISPATCH_METHOD, VT_I4, (void*)&result, parms, strKey);
		return result;
	}
	long FindShapeWithKeyInComp1(long compshape, LPWSTR strKey)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_UNKNOWN;
		InvokeHelper(0x20a, DISPATCH_METHOD, VT_I4, (void*)&result, parms, compshape, strKey);
		return result;
	}
	long FindShapeWithKeyInComp2(long compshape, LPWSTR strKey)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_UNKNOWN;
		InvokeHelper(0x20b, DISPATCH_METHOD, VT_I4, (void*)&result, parms, compshape, strKey);
		return result;
	}
	long FindShapeWithKeyInComp3(long compshape, LPWSTR strKey)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_UNKNOWN;
		InvokeHelper(0x20c, DISPATCH_METHOD, VT_I4, (void*)&result, parms, compshape, strKey);
		return result;
	}
	void RotateFromCenter(long shape, short angle)
	{
		static BYTE parms[] = VTS_I4 VTS_I2;
		InvokeHelper(0x20d, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, angle);
	}
	void MoveCenterTo(long shape, long xNew, long yNew)
	{
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x20e, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, xNew, yNew);
	}
	void ScaleFromCenter(long shape, double dX, double dY)
	{
		static BYTE parms[] = VTS_I4 VTS_R8 VTS_R8;
		InvokeHelper(0x20f, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, dX, dY);
	}
	void InitLinkTypeAndArrow(short nLinkType, short nArrowType)
	{
		static BYTE parms[] = VTS_I2 VTS_I2;
		InvokeHelper(0x210, DISPATCH_METHOD, VT_EMPTY, NULL, parms, nLinkType, nArrowType);
	}
	long AddShapeWithoutUndo(long shape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x211, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape);
		return result;
	}
	long GetCanvasWidth2()
	{
		long result;
		InvokeHelper(0x212, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long GetCanvasHeight2()
	{
		long result;
		InvokeHelper(0x213, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long LoadNewTrsFile(LPWSTR strTrsFile)
	{
		long result;
		static BYTE parms[] = VTS_UNKNOWN;
		InvokeHelper(0x214, DISPATCH_METHOD, VT_I4, (void*)&result, parms, strTrsFile);
		return result;
	}
	long AddShapeByTrs(long x, long y, long nWidth, long nHeight, LPWSTR strKey1)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_UNKNOWN;
		InvokeHelper(0x215, DISPATCH_METHOD, VT_I4, (void*)&result, parms, x, y, nWidth, nHeight, strKey1);
		return result;
	}
	void ShowPortPinName(long bShow)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x216, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bShow);
	}
	void RemoveAllFromSelection(long bRedraw)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x217, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bRedraw);
	}
	unsigned long GetShapeColorProp2(long shape, long nPropID)
	{
		unsigned long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x218, DISPATCH_METHOD, VT_UI4, (void*)&result, parms, shape, nPropID);
		return result;
	}
	void DoBendFree()
	{
		InvokeHelper(0x219, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	long IsAllowBendFree()
	{
		long result;
		InvokeHelper(0x21a, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	short GetSubPathCount(long pathshape)
	{
		short result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x21b, DISPATCH_METHOD, VT_I2, (void*)&result, parms, pathshape);
		return result;
	}
	short GetPointCountSubPath(long pathshape, short segment)
	{
		short result;
		static BYTE parms[] = VTS_I4 VTS_I2;
		InvokeHelper(0x21c, DISPATCH_METHOD, VT_I2, (void*)&result, parms, pathshape, segment);
		return result;
	}
	short GetSegmentType(long pathshape, short segment, short ptIndex)
	{
		short result;
		static BYTE parms[] = VTS_I4 VTS_I2 VTS_I2;
		InvokeHelper(0x21d, DISPATCH_METHOD, VT_I2, (void*)&result, parms, pathshape, segment, ptIndex);
		return result;
	}
	void SelectNewShape(long shape)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x21e, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape);
	}
	void SetAllowHoleLink(long bEnable)
	{
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x21f, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bEnable);
	}
	void DoShowKeyDlg()
	{
		InvokeHelper(0x220, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	double ConvertToMapLog(double dConvertValue, short nUnit, long bVert)
	{
		double result;
		static BYTE parms[] = VTS_R8 VTS_I2 VTS_I4;
		InvokeHelper(0x221, DISPATCH_METHOD, VT_R8, (void*)&result, parms, dConvertValue, nUnit, bVert);
		return result;
	}
	double GetGaugeCurrentValue(long shape)
	{
		double result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x222, DISPATCH_METHOD, VT_R8, (void*)&result, parms, shape);
		return result;
	}
	void SetGaugeCurrentValue(long shape, double dValue)
	{
		static BYTE parms[] = VTS_I4 VTS_R8;
		InvokeHelper(0x223, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, dValue);
	}
	double GetCurrentValue(long shape)
	{
		double result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x224, DISPATCH_METHOD, VT_R8, (void*)&result, parms, shape);
		return result;
	}
	void SetCurrentValue(long shape, double dValue)
	{
		static BYTE parms[] = VTS_I4 VTS_R8;
		InvokeHelper(0x225, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, dValue);
	}
	long GetShapeID(long shape)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x226, DISPATCH_METHOD, VT_I4, (void*)&result, parms, shape);
		return result;
	}
	void SetShapeID(long shape, long nId)
	{
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x227, DISPATCH_METHOD, VT_EMPTY, NULL, parms, shape, nId);
	}
	long FindShapeByID(long nId)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x228, DISPATCH_METHOD, VT_I4, (void*)&result, parms, nId);
		return result;
	}
	void StartRun()
	{
		InvokeHelper(0x229, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	LPDISPATCH Convert(long shape)
	{
		LPDISPATCH result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x22a, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, shape);
		return result;
	}
	void LockUpdate(BOOL bLock)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x22b, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bLock);
	}
	BOOL IsLockUpdate()
	{
		BOOL result;
		InvokeHelper(0x22c, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	LPDISPATCH ConvertToGroup(long shape)
	{
		LPDISPATCH result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x22d, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, shape);
		return result;
	}
	LPDISPATCH ConvertToLink(long shape)
	{
		LPDISPATCH result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x22e, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, shape);
		return result;
	}
	LPDISPATCH ConvertToPortsShape(long shape)
	{
		LPDISPATCH result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x22f, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, shape);
		return result;
	}
	LPDISPATCH ConvertToPortShape(long shape)
	{
		LPDISPATCH result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x230, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, shape);
		return result;
	}
	LPDISPATCH ConvertToEFormShape(long shape)
	{
		LPDISPATCH result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x231, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, shape);
		return result;
	}
	void RemoveAllToolBoxPages()
	{
		InvokeHelper(0x232, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	BOOL ToolboxLoadfile(LPCTSTR strFile)
	{
		BOOL result;
		static BYTE parms[] = VTS_BSTR;
		InvokeHelper(0x233, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, strFile);
		return result;
	}
	void HideCanvasBorder()
	{
		InvokeHelper(0x234, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void HideAllScrollBars()
	{
		InvokeHelper(0x235, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	void ShowToolBar(BOOL bShow)
	{
		static BYTE parms[] = VTS_BOOL;
		InvokeHelper(0x236, DISPATCH_METHOD, VT_EMPTY, NULL, parms, bShow);
	}
	void OpenSVG(LPCTSTR lpszFile)
	{
		static BYTE parms[] = VTS_BSTR;
		InvokeHelper(0x237, DISPATCH_METHOD, VT_EMPTY, NULL, parms, lpszFile);
	}
	void SaveSvgToFile(LPCTSTR lpszFile)
	{
		static BYTE parms[] = VTS_BSTR;
		InvokeHelper(0x238, DISPATCH_METHOD, VT_EMPTY, NULL, parms, lpszFile);
	}
	void AboutBox()
	{
		InvokeHelper(DISPID_ABOUTBOX, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	long GetHandle()
	{
		long result;
		InvokeHelper(0x4e86, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}

	// _DUCCSVG 
 
public:
	long GetCanvasWidth();
	void SetCanvasWidth(long);
	long GetCanvasHeight();
	void SetCanvasHeight(long);
	LPDISPATCH GetParent();
	void SetParent(LPDISPATCH);
	LPDISPATCH GetRoot();
	void SetRoot(LPDISPATCH);
	CXDPage GetActivePage();
	void SetActivePage(LPDISPATCH);
	CXDWindow GetActiveWindow();
	void SetActiveWindow(LPDISPATCH);


};
